﻿Imports C1.Win
Imports C1.Win.C1FlexGrid

Public Class VerticalFlexGridScrollManager

    Public Shared Sub HandleScroll(sb As VScrollBar, grids As IEnumerable(Of C1FlexGrid))
        'setup minimum and maximum for 0 to 100%
        sb.Minimum = 0
        sb.Maximum = 100
        'add handler to handle scroll
        AddHandler sb.Scroll, AddressOf Scrolled
        'tag the list of grids to be scrolled
        sb.Tag = grids
        'setup grids, hide theier vertical scroll bar
        For Each grid In grids
            grid.ScrollBars = ScrollBars.Horizontal
        Next
    End Sub

    Private Shared Sub Scrolled(sender As Object, e As ScrollEventArgs)
        'get scroll bar
        Dim sb = CType(sender, VScrollBar)
        'scroll each grid

        For Each grid As C1FlexGrid In CType(sb.Tag, IEnumerable(Of C1FlexGrid))
            grid.ScrollPosition = New Point(grid.ScrollPosition.X, -GetScrollPosition(grid, e.NewValue))
        Next

    End Sub

    'gets the scroll position to set according to the percentage
    Private Shared Function GetScrollPosition(grid As C1FlexGrid, percent As Integer) As Integer
        Dim height = grid.Rows(grid.Rows.Count - 1).Bottom - grid.ScrollableRectangle.Height
        Dim scroll = (height * percent) / 100
        Return scroll
    End Function
End Class
